<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1100">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon
            color="deep-orange accent-4

"
          >
            mdi-chart-areaspline
          </v-icon>
          Seguimiento
        </v-btn>
      </template>
      <v-card :class="'modalSystem'">
        <v-card class="container">
          <h3 class="text-center">SEGUIMIENTO PLANIFICACIÓN</h3>
          <v-btn icon right @click="dialog = false" class="float-right">
            <v-icon>mdi-close</v-icon>
          </v-btn>
          <form>
            <div class="d-flex justify-space-around mt-5">
              <div class="row">
                <div class="col-3">
                  <v-select
                    :items="combos.stages"
                    item-value="id"
                    item-text="etapa"
                    label="Etapa"
                    v-model="stage"
                    outlined
                  ></v-select>
                </div>
                <div class="col-3">
                  <v-select
                    :items="combos.activities"
                    item-value="id"
                    item-text="nombre"
                    label="Actividad"
                    v-model="activity"
                    outlined
                  ></v-select>
                </div>
                <div class="col-3">
                  <v-menu
                    v-model="menu"
                    :close-on-content-click="false"
                    :nudge-right="40"
                    transition="scale-transition"
                    offset-y
                    min-width="auto"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="registerDate"
                        label="Fecha Registro"
                        prepend-icon="mdi-calendar"
                        readonly
                        outlined
                        v-bind="attrs"
                        v-on="on"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="registerDate"
                      @input="menu = false"
                    ></v-date-picker>
                  </v-menu>
                </div>
                <div class="col-3">
                  <v-select
                    label="Avance Real"
                    :items="combos.percentages"
                    v-model="progress"
                    outlined
                  ></v-select>
                </div>
              </div>
            </div>
            <div class="d-flex flex-row-reverse mt-6">
              <v-btn
                outlined
                color="indigo lighten-2"
                class="
                  button-text
                  v-btn v-btn--outlined v-btn--rounded
                  theme--light
                  v-size--default
                  tway-violet--text
                  mx-lg-auto
                "
                @click="savePlanificationTracing"
              >
                <v-icon color="purple"> mdi-content-save </v-icon>
                Guardar Avance Real
              </v-btn>
            </div>
            <v-alert
              v-model="alertBox.on"
              border="right"
              colored-border
              type="error"
              elevation="2"
              class="ml-2 mr-2"
            >
              {{ alertBox.message }}
            </v-alert>
          </form>
          <v-simple-table v-if="tracingList.length > 0" class="table mt-5">
            <template>
              <thead>
                <tr>
                  <th class="text-left" scope="col">#No</th>
                  <th class="text-left" scope="col">Etapa</th>
                  <th class="text-left" scope="col">Indicador</th>
                  <th class="text-left" scope="col">Fecha</th>
                  <th class="text-left" scope="col">Valor Esperado</th>
                  <th class="text-left" scope="col">Valor Actual</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(entry, i) in tracingList" :key="i">
                  <th scope="row">{{ ++i }}</th>
                  <td>{{ entry.etapa }}</td>
                  <td>{{ entry.actividad }}</td>
                  <td>{{ entry.date1 }}</td>
                  <td>{{ entry.esperado }}</td>
                  <td>{{ entry.avanceactual }}</td>
                  <td>
                    <v-icon small color="error" @click="deleteItem(entry)">
                      delete
                    </v-icon>
                  </td>
                </tr>
              </tbody>
            </template>
          </v-simple-table>
          <v-alert
            v-else
            class="text-center mt-8"
            success
            shaped
            outlined
            color="deep-orange"
            icon="mdi-fire"
          >
            No registra seguimiento de planficación. Registre para que aparezcan
            datos.</v-alert
          >
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import PlanificationService from "@/services/pmo/planification/planificationService";

export default {
  data: (vm) => {
    return {
      dateFormatted: vm.formatDate(
        new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
          .toISOString()
          .substr(0, 10)
      ),
      tracingList: [],
      combos: {
        stages: [],
        activities: [],
        percentages: [],
      },
      stage: 0,
      activity: 0,
      progress: 0,
      registerDate: "",
      dialog: false,
      alertBox: {
        on: false,
        message: "",
      },
    };
  },
  watch: {
    date() {
      this.dateFormatted = this.formatDate(this.date);
    },
    stage(stageId) {
      PlanificationService.getActivitiesByStage(stageId)
        .then((data) => {
          this.combos.activities = data;
        })
        .catch((err) => console.dir(err));
    },
  },
  methods: {
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${day}/${month}/${year}`;
    },
    savePlanificationTracing() {
      const request = {
        etapaId: this.stage,
        actividadId: this.activity,
        fecha: this.registerDate,
        avanceReal: this.progress,
      };
      PlanificationService.savePlanificationTracing(request)
        .then(() => {
          alert("Seguimiento registrado");
          this.clearForm();
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alertBox.message = message;
          this.alertBox.on = true;
          console.dir(err);
        })
        .finally(() => {
          setTimeout(() => (this.alertBox.on = false), 4000);
          this.clearForm();
        });
    },
    clearForm() {
      this.stage = 0;
      this.activity = 0;
      this.progress = 0;
      this.registerDate = "";
    },
    deleteItem() {},
  },
  mounted() {
    // FIX: Debe ser cambiado por una llamada dinámica para averiguar el project Id
    const projectId = 1;
    PlanificationService.getProjectStages(projectId)
      .then((data) => {
        this.combos.stages = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getPercentages()
      .then((data) => {
        this.combos.percentages = data;
      })
      .catch((err) => console.dir(err));
  },
};
</script>
<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.edit_row .v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
</style>
